package com.zt.plat.module.qms.business.config.controller.admin;

import com.zt.plat.module.qms.business.config.controller.vo.*;
import org.springframework.web.bind.annotation.*;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.apache.commons.lang3.StringUtils;
import org.springframework.security.access.prepost.PreAuthorize;
import com.zt.plat.framework.business.interceptor.BusinessControllerMarker;

import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Operation;

import jakarta.validation.*;
import jakarta.servlet.http.*;
import java.util.*;
import java.io.IOException;

import com.zt.plat.framework.common.pojo.vo.BatchDeleteReqVO;
import com.zt.plat.framework.common.pojo.PageParam;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.pojo.CommonResult;
import com.zt.plat.framework.common.util.object.BeanUtils;
import com.zt.plat.framework.datapermission.core.annotation.DeptDataPermissionIgnore;

import static com.zt.plat.framework.common.pojo.CommonResult.success;

import com.zt.plat.framework.excel.core.util.ExcelUtils;

import com.zt.plat.framework.apilog.core.annotation.ApiAccessLog;
import static com.zt.plat.framework.apilog.core.enums.OperateTypeEnum.*;

import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodDO;
import com.zt.plat.module.qms.business.config.service.ConfigAssayMethodService;

import cn.hutool.core.collection.CollUtil;

@Tag(name = "管理后台 - 检测方法配置")
@RestController
@RequestMapping("/qms/config-assay-method")
@Validated
@DeptDataPermissionIgnore(enable = "true")
public class ConfigAssayMethodController implements BusinessControllerMarker {


    @Resource
    private ConfigAssayMethodService configAssayMethodService;

    @PostMapping("/create")
    @Operation(summary = "创建检测方法配置")
    //@PreAuthorize("@ss.hasPermission('qms:config-assay-method:create')")
    public CommonResult<ConfigAssayMethodRespVO> createConfigAssayMethod(@Valid @RequestBody ConfigAssayMethodSaveReqVO createReqVO) {
        return success(configAssayMethodService.createConfigAssayMethod(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "更新检测方法配置")
    //@PreAuthorize("@ss.hasPermission('qms:config-assay-method:update')")
    public CommonResult<Boolean> updateConfigAssayMethod(@Valid @RequestBody ConfigAssayMethodSaveReqVO updateReqVO) {
        configAssayMethodService.updateConfigAssayMethod(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除检测方法配置")
    @Parameter(name = "id", description = "编号", required = true)
    //@PreAuthorize("@ss.hasPermission('qms:config-assay-method:delete')")
    public CommonResult<Boolean> deleteConfigAssayMethod(@RequestParam("id") Long id) {
        configAssayMethodService.deleteConfigAssayMethod(id);
        return success(true);
    }

    @DeleteMapping("/delete-list")
    @Parameter(name = "ids", description = "编号", required = true)
    @Operation(summary = "批量删除检测方法配置")
                //@PreAuthorize("@ss.hasPermission('qms:config-assay-method:delete')")
    public CommonResult<Boolean> deleteConfigAssayMethodList(@RequestBody BatchDeleteReqVO req) {
        configAssayMethodService.deleteConfigAssayMethodListByIds(req.getIds());
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得检测方法配置")
    @Parameter(name = "id", description = "编号", required = true, example = "1024")
    //@PreAuthorize("@ss.hasPermission('qms:config-assay-method:query')")
    public CommonResult<ConfigAssayMethodRespVO> getConfigAssayMethod(@RequestParam("id") Long id) {
        ConfigAssayMethodDO configAssayMethod = configAssayMethodService.getConfigAssayMethod(id);
        return success(BeanUtils.toBean(configAssayMethod, ConfigAssayMethodRespVO.class));
    }

    @GetMapping("/list")
    @Operation(summary = "获得检测方法配置列表")
    //@PreAuthorize("@ss.hasPermission('qms:config-assay-method:query')")
    public CommonResult<List<ConfigAssayMethodExtendRespVO>> getConfigAssayMethodList(@Valid ConfigAssayMethodReqVO reqVO) {
    	List<ConfigAssayMethodExtendRespVO> list = new ArrayList<>();
        List<ConfigAssayMethodExtendRespVO> listResult = configAssayMethodService.getConfigAssayMethodList(reqVO);
        if (StringUtils.isNotBlank(reqVO.getProjectSimpleNames())) {
        	List<String> projectSimpoleNameList = Arrays.asList(reqVO.getProjectSimpleNames().split(","));
			for (ConfigAssayMethodExtendRespVO configAssayMethodExtendRespVO : listResult) {
				if (CollUtil.isNotEmpty(configAssayMethodExtendRespVO.getProjectSimpleNameList()) && configAssayMethodExtendRespVO.getProjectSimpleNameList().containsAll(projectSimpoleNameList)) {
					list.add(configAssayMethodExtendRespVO);
				}
			}
		} else {
			list.addAll(listResult);
		}
        
        return success(list);
    }

    @GetMapping("/page")
    @Operation(summary = "获得检测方法配置分页")
    //@PreAuthorize("@ss.hasPermission('qms:config-assay-method:query')")
    public CommonResult<PageResult<ConfigAssayMethodExtendRespVO>> getConfigAssayMethodPage(@Valid ConfigAssayMethodPageReqVO pageReqVO) {
        PageResult<ConfigAssayMethodExtendRespVO> pageResult = configAssayMethodService.getConfigAssayMethodPage(pageReqVO);
        return success(pageResult);
    }

    @GetMapping("/export-excel")
    @Operation(summary = "导出检测方法配置 Excel")
    //@PreAuthorize("@ss.hasPermission('qms:config-assay-method:export')")
    @ApiAccessLog(operateType = EXPORT)
    public void exportConfigAssayMethodExcel(@Valid ConfigAssayMethodPageReqVO pageReqVO,
              HttpServletResponse response) throws IOException {
        pageReqVO.setPageSize(PageParam.PAGE_SIZE_NONE);
        List<ConfigAssayMethodExtendRespVO> list = configAssayMethodService.getConfigAssayMethodPage(pageReqVO).getList();
        // 导出 Excel
        ExcelUtils.write(response, "检测方法配置.xls", "数据", ConfigAssayMethodRespVO.class,
                        BeanUtils.toBean(list, ConfigAssayMethodRespVO.class));
    }

}